#include<cstdio>
#include<cstdlib>
#include<cassert>
#include<vector>
#include<algorithm>
#include<map>

using namespace std;

#define MAXN 2222
long long A[MAXN];
long long N, X;

int print_ans(vector<int> ans) {
  if (!ans.size()) {
    printf("Konec sveta se odklada\n");
  }
  else {
    for (int i = 0; i < ans.size(); ++i) {
      swap(ans[i], ans[rand() % (i + 1)]);
    }
    bool printed = false;
    for (int i = 0; i < ans.size(); ++i) {
      if (ans[i] == 0) continue;
      if (printed) printf(" ");
      printed = true;
      printf("%d", ans[i]);
    }
    printf("\n");
  }
  return 0;
}

int solve_two_numbers() {
  vector<int> ans;
  for (int i = 0; i < N; ++i) for (int j = 0; j < i; ++j) {
    if (A[i] + A[j] == X) {
      ans.push_back(A[i]);
      ans.push_back(A[j]);
      return print_ans(ans);
    }
  }
  return print_ans(ans);
}

int solve_three() {
  vector<int> ans;
  int steps = 0;
  for (int i = 0; i < N; ++i)
    for (int j = 0; j < i; j++)
      for (int k = 0; k < j; k++) {
        steps++;
	if (steps > 100000000) return print_ans(ans);
	if (A[i] + A[j] + A[k] == X) {
	  ans.push_back(A[i]);
	  ans.push_back(A[j]);
	  ans.push_back(A[k]);
	  return print_ans(ans);
	}
      }
  return print_ans(ans);
}

int solve_slow() {
  vector<int> ans;
  int steps = 0;
  for (int i = 0; i < N; ++i)
    for (int j = 0; j < i; j++)
      for (int k = 0; k < j; k++)
        for (int l = 0; l < k; l++) {
          steps++;
          if (steps > 100000000) return print_ans(ans);
	  if (A[i] + A[j] + A[k] + A[l] == X) {
	    ans.push_back(A[i]);
	    ans.push_back(A[j]);
	    ans.push_back(A[k]);
	    ans.push_back(A[l]);
	    return print_ans(ans);
	  }
	}
  return print_ans(ans);
}

#define MAX 11111
long long mm[MAX];
int solve_7points() {
  assert(X <= 10000); // 7 bodu
  for (int i = 0; i < MAX; ++i) mm[i] = -1;

  vector<int> ans;
  int N1 = N / 2;
  for (int i = 0; i < N1; ++i) for (int j = 0; j < i; ++j) {
    if (A[i] + A[j] < MAX) {
      mm[A[i] + A[j]] = A[i];
    }
  }
  for (int i = N1; i < N; ++i) for (int j = N1; j < i; ++j) {
    long long sum = A[i] + A[j];
    if (sum > X) continue;
    long long remaining = X - sum;
    if (mm[remaining] != -1) {
      ans.push_back(A[i]);
      ans.push_back(A[j]);
      ans.push_back(mm[remaining]);
      ans.push_back(remaining - mm[remaining]);
      return print_ans(ans);
    }
  }
  return print_ans(ans);
}

map<long long, long long> m;

int solve_overflow() {
  vector<int> ans;
  int N1 = N / 2;
  for (int i = 0; i < N1; ++i) for (int j = 0; j < i; ++j) {
    m[A[i] + A[j]] = A[i];
  }
  for (int i = N1; i < N; ++i) for (int j = N1; j < i; ++j) {
    long long sum = A[i] + A[j];
    for (long long k = 0; k < 5; ++k) {
      long long remaining = X - sum + (k << 32);
      if (m.count(remaining)) {
        ans.push_back(A[i]);
        ans.push_back(A[j]);
        ans.push_back(m[remaining]);
        ans.push_back(remaining - m[remaining]);
        return print_ans(ans);
      }
    }
  }
  return print_ans(ans);
}

int solve_fast() {
  vector<int> ans;
  int N1 = N / 2;
  for (int i = 0; i < N1; ++i) for (int j = 0; j < i; ++j) {
    m[A[i] + A[j]] = A[i];
  }
  for (int i = N1; i < N; ++i) for (int j = N1; j < i; ++j) {
    long long sum = A[i] + A[j];
    long long remaining = X - sum;
    if (m.count(remaining)) {
      ans.push_back(A[i]);
      ans.push_back(A[j]);
      ans.push_back(m[remaining]);
      ans.push_back(remaining - m[remaining]);
      return print_ans(ans);
    }
  }
  return print_ans(ans);
}

int main(int argv, char *argc[]) {
  scanf("%lld%lld", &X, &N);
  assert(1 <= N && N <= 2000);
  assert(1 <= X && X <= 1000000000);
  for (int i = 0; i < N; ++i) {
    scanf("%lld", A + i);
    assert(1 <= A[i] && A[i] <= 1000000000);
  }
  for (int i = 0; i < 3; ++i) A[N++] = 0;

  return solve_two_numbers(); // 3 body
  return solve_7points();     // 7 bodu
  return solve_three();       // hleda pomalu trojice
  return solve_slow();        // hleda pomalu ctverice
  return solve_fast();        // O(N^2 log(N))
}
