#include <stdio.h>
#include <stdlib.h>

#define MX 1000000000

struct par
{
  unsigned n, sof, mx;
} pars[13] =
{
    {2000, 2, MX}, /* Soucet dvou. */
    {800, 2, 10000}, /* X <= 10000, soucet dvou. */
    {2000, 3, 10000}, /* X <= 10000. */
    {500, 4, 10000}, /* X <= 10000. */
    {1000, 4, 10000}, /* X <= 10000. */
    {2000, 4, 10000}, /* X <= 10000. */
    {1000, 4, MX / 1000},
    {1000, 4, MX / 1000},
    {1500, 4, MX / 1000},
    {1500, 4, MX / 1000},
    {2000, 4, MX / 100},
    {2000, 4, MX / 100},
    {2000, 4, MX}
};

static unsigned adata[2000];
static unsigned sadata[2000];

static int
already_present (unsigned in[], int l, unsigned a)
{
  int i;

  for (i = 0; i < l; i++)
    if (in[i] == a)
      return 1;

  return 0;
}

static void
gen_dist_num (unsigned k, unsigned r, unsigned in[])
{
  unsigned a;

  while (1)
    {
      a = rand () % r + 1;
      if (!already_present (in, k, a))
	break;
    }

  in[k] = a;
}

static int
cmpuns (const void *a, const void *b)
{
  unsigned va = *(unsigned *) a;
  unsigned vb = *(unsigned *) b;

  if (va < vb)
    return -1;
  if (va > vb)
    return 1;

  return 0;
}


static int
is_sum_at_most (unsigned ns[], unsigned n, unsigned x, unsigned sof)
{
  unsigned i, j, y, z;

  if (bsearch (&x, ns, n, sizeof (unsigned), cmpuns))
    return 1;

  if (sof == 1)
    return 0;

  for (i = 0; i < n; i++)
    {
      if (ns[i] > x)
	continue;

      z = x - ns[i];
      if (z > ns[i] && bsearch (&z, ns, n, sizeof (unsigned), cmpuns))
	return 1;
    }

  if (sof == 2)
    return 0;

  for (i = 0; i < n; i++)
    for (j = i + 1; j < n; j++)
      {
	y = ns[i] + ns[j];

	if (y > x)
	  continue;

	z = x - y;

	if (z > ns[j] && bsearch (&z, ns, n, sizeof (unsigned), cmpuns))
	  return 1;
      }

  if (sof > 3)
    abort ();

  return 0;
}

static void
gen_rand (FILE *f, struct par *p)
{
  unsigned i;
  unsigned chosen[4], s;

  for (i = 0; i < p->n; i++)
    {
      gen_dist_num (i, p->mx / (p->sof - 1) * 4 / 5, adata);
      sadata[i] = adata[i];
    }

  qsort (sadata, p->n, sizeof (unsigned), cmpuns);

  while (1)
    {
      s = 0;
      for (i = 0; i < p->sof; i++)
	{
	  gen_dist_num (i, p->n, chosen);
	  s += adata[chosen[i] - 1];
	}

      if (s < p->mx / 2 || s > p->mx)
	continue;

      if (!is_sum_at_most (sadata, p->n, s, p->sof - 1))
	break;
    }

  fprintf (f, "%d %d\n", s, p->n);
  for (i = 0; i < p->n; i++)
    fprintf (f, "%d\n", adata[i]);
}

int main (void)
{
  FILE *f;
  int i;
  char buf[100], c;

  srand (0);

  /* X <= 10^4 */
  f = fopen ("p3-4data/in.01a", "w");
  fprintf (f, "20 6\n1\n2\n3\n4\n10\n1000000000\n");
  fclose (f);
  f = fopen ("p3-4data/hint.01a", "w");
  fprintf (f, "0\n");
  fclose (f);

  f = fopen ("p3-4data/in.01b", "w");
  fprintf (f, "20 6\n1\n2\n3\n4\n1000000000\n11\n");
  fclose (f);
  f = fopen ("p3-4data/hint.01b", "w");
  fprintf (f, "1\n");
  fclose (f);

  /* X <= 10^4, X soucet dvou */
  f = fopen ("p3-4data/in.02a", "w");
  fprintf (f, "17 6\n2\n4\n6\n8\n10\n12\n");
  fclose (f);
  f = fopen ("p3-4data/hint.02a", "w");
  fprintf (f, "0\n");
  fclose (f);

  f = fopen ("p3-4data/in.02b", "w");
  fprintf (f, "10 6\n2\n4\n6\n8\n10\n12\n");
  fclose (f);
  f = fopen ("p3-4data/hint.02b", "w");
  fprintf (f, "1\n");
  fclose (f);

  for (i = 3; i <= 15; i++)
    for (c = 'a'; c <= 'b'; c++)
      {
	fprintf (stderr, "%02d%c\n", i, c);
	sprintf (buf, "p3-4data/in.%02d%c", i, c);
	f = fopen (buf, "w");
	gen_rand (f, pars + i - 3);
	fclose (f);
	sprintf (buf, "p3-4data/hint.%02d%c", i, c);
	f = fopen (buf, "w");
	fprintf (f, "1\n");
	fclose (f);
      }

  return 0;
}
